
// Thomas Scherrer
// BLUE EBAY LCD ENERGYMETER HACK OUT VOLTAGE CURRENT POWER FROM SPI AND SEND OUT VIA SERIAL PORT
//Mega 2560

#include <LiquidCrystal.h>
LiquidCrystal lcd(8, 13, 9, 4, 5, 6, 7);

#define SET(x,y) (x |=(1<<y))              //-Bit set/clear macros
#define CLR(x,y) (x &= (~(1<<y)))               // |
#define CHK(x,y) (x & (1<<y))                   // | проверка "бит Y установлен?"


// define ports and signals from ENERGY METER
#define DD_MISO   50  //out not connected
#define DD_MOSI   51  // in  R9 right side (DATA FROM ENERGY CHIP)
#define DD_SCK    52  // in  U2 pin  12 (CLOCK TO ENERGY CHIP)
#define DD_SS     53  // in  U2 pin 11 (WORD LATCH TO ENERGU CHIP)
#define DD_RESYNC 49 // input  U2 7 (LATCH to DISPLAY CHIP, USED TO SYNC DATA BYTES INTO CORRECT VARIABLES)



uint8_t byte_received;


uint8_t rxv1 = 0;
uint8_t rxv2 = 0;
uint8_t rxv3 = 0;

uint8_t rxc1 = 0;
uint8_t rxc2 = 0;
uint8_t rxc3 = 0;

uint8_t rxw1 = 0;
uint8_t rxw2 = 0;
uint8_t rxw3 = 0;
uint8_t rxw4 = 0;
unsigned char commandbyte; // the energy meter IC gets a command byte from the NEC CPU at start of each datapackage, it dont contain any usefull info for us)
unsigned char commandbyteU;

float voltfloat = 0;
int   voltint = 0;
float voltscalefactor = 0.306;   // для большей точности подобрать

float currentfloat = 0;
int   currentint = 0;
float currentscalefactor = 1.553;

long  wattlong = 0;
float wattfloat = 0;
int   wattint = 0;
float wattscalefactor = 15.014;


 unsigned char del1;
 unsigned char del2;  

// --------------------------------------------------------------------------------------------------------

uint8_t spi_recv_char()
{
  //пока не выставлен флаг окончания передачи, принимаем биты
  while (!(SPSR & (1 << SPIF))) {};
  //позвращяем содержимое регистра данных SPI
  return SPDR;
}

// --------------------------------------------------------------------------------------------------------

void setup() {
  pinMode(DD_MOSI, INPUT);
  pinMode(DD_MISO, OUTPUT);  // не используем
  pinMode(DD_SCK, INPUT);
  pinMode(DD_SS, INPUT);
  pinMode(DD_RESYNC, INPUT);

  //обнуляем регистр управления SPI
  SPCR = B00000000;
  //разрешаем работу SPI
  SPCR |= (1 << SPE) | (1 << CPHA);

  lcd.clear();
  lcd.begin(16, 2);
  lcd.print("power test");
  delay(1000);
  lcd.clear();
}
 
void Delay (unsigned char del0)  //input in 1.4uS
{
  while(del0>0) del0--;
}

void DelaymS (unsigned char del2)  // input in mS at 8MHz
{
  while (del2>0)
  {
    del2--;
  del1=9;  // adjust here
  while(del1>0)
  {
    del1--;
    Delay(79); // and here
  }
  }
}


void loop() {
  // Чтение состояния(лог. 0) на порту ввода-вывода (4 вывод порта B):
  while (!(PINL & (1 << PINL0))) // if(digitalRead(4) == LOW)

  {
    DelaymS(20);
  }

  commandbyteU = spi_recv_char(); // we dont use the command byte, but we must read the first 8 bits.
  rxv1 = spi_recv_char();  //
  rxv2 = spi_recv_char();  //
  rxv3 = spi_recv_char();  //  3 x 8 bits for voltage

  commandbyte = spi_recv_char(); // we dont use the command byte, but we must read the first 8 bits.
  rxc1 = spi_recv_char(); //
  rxc2 = spi_recv_char(); //
  rxc3 = spi_recv_char(); // 3 x 8 bits for current

  commandbyte = spi_recv_char(); // we dont use the command byte, but we must read the first 8 bits.
  rxw1 = spi_recv_char(); //
  rxw2 = spi_recv_char(); //
  rxw3 = spi_recv_char(); //
  rxw4 = spi_recv_char(); // 4 x 8 bits for watts

  voltfloat = (rxv2 * 256) + rxv3;
  voltfloat = voltfloat * voltscalefactor;
  voltint = (voltfloat/10);
  lcd.setCursor(0, 0);
  lcd.print(rxv1);
  lcd.setCursor(4, 0);
  lcd.print(rxv2);
  lcd.setCursor(8, 0);
  lcd.print(rxv3);
  lcd.setCursor(12, 0);
  lcd.print(voltint);

 
  currentfloat = (rxc1 * 256) + rxc2;
  currentfloat = currentfloat * currentscalefactor;
    lcd.setCursor(0, 1);
    lcd.print(rxc1);
    lcd.setCursor(4, 1);
    lcd.print(rxc2);
    lcd.setCursor(8, 1);
    lcd.print(rxc3);
  //  lcd.setCursor(13, 0);
  //  lcd.print(ener);

  wattfloat = ((float)rxw1 * 256) + (float)rxw2 + ((float)rxw3 / 256);
  wattfloat = wattfloat * wattscalefactor;
 }

